#!/bin/sh

#
# run this script after postinstall.sh
#

thedir="/Developer/Git"
the64dir="/Developer/Git/ppc64"
thefatdir="/Developer/Git/fat"

rm -r -f "${thefatdir}"
mkdir -p "${thefatdir}"/libexec/git-core

libexec_binaries=`find ${thedir}/libexec/git-core -maxdepth 1`

save_wd=`pwd`
cd ${the64dir}/libexec/git-core

for theFile in $libexec_binaries
do
        filename=`basename "${theFile}"`
        ppc_binary=`file -h "${theFile}" | grep ppc`
        if [ ! -z "${ppc_binary}" ];
          then
                echo copy 64-bit and 32-bit binaries of "${filename}"
                cp "${filename}" ${thefatdir}/libexec/git-core/"${filename}".ppc64
                cp ${thedir}/libexec/git-core/"${filename}" ${thefatdir}/libexec/git-core/"${filename}".ppc32
                echo create fat binary "${filename}".fat
                lipo -create ${thefatdir}/libexec/git-core/"${filename}".ppc32 ${thefatdir}/libexec/git-core/"${filename}".ppc64 -output ${thefatdir}/libexec/git-core/"${filename}".fat
                lipo -info ${thefatdir}/libexec/git-core/"${filename}".fat
                #rm ${thefatdir}/libexec/git-core/"${filename}".ppc32
                #rm ${thefatdir}/libexec/git-core/"${filename}".ppc64
                mv ${thefatdir}/libexec/git-core/"${filename}".fat ${thefatdir}/libexec/git-core/"${filename}"
                echo copy fat binary to ${thedir}/libexec/git-core/
                cp ${thefatdir}/libexec/git-core/"${filename}" ${thedir}/libexec/git-core/
        fi
done

cd "${save_wd}"

rm -r -f "${the64dir}"
# rm -f -r "${thefatdir}"
