#!/bin/sh

thedir="/Developer/Git"

#  git-cvsserver is a perl script
rm "${thedir}"/bin/git-cvsserver
wd=`pwd`
cd "${thedir}"/bin
ln -s ../libexec/git-core/git-cvsserver git-cvsserver
cd "${wd}"

#  git-shell
rm "${thedir}"/bin/git-shell
wd=`pwd`
cd "${thedir}"/bin
ln -s ../libexec/git-core/git-shell git-shell
cd "${wd}"

#  git-upload-pack
rm "${thedir}"/bin/git-upload-pack
wd=`pwd`
cd "${thedir}"/bin
ln -s ../libexec/git-core/git-upload-pack git-upload-pack
cd "${wd}"

therootdir="/Developer/Git/rootdir/"  # set to "/" to use real root directory

mkdir -p "${therootdir}"
mkdir -p "${therootdir}"usr
mkdir -p "${therootdir}"usr/bin
mkdir -p "${therootdir}"usr/lib
mkdir -p "${therootdir}"usr/libexec
mkdir -p "${therootdir}"usr/share/man/man1
mkdir -p "${therootdir}"usr/share/man/man3
mkdir -p "${therootdir}"usr/share/man/man5
mkdir -p "${therootdir}"usr/share/man/man7

# DEFAULT_GIT_TEMPLATE_DIR "/usr/share/git-core/templates"
rm -r -f "${therootdir}"usr/share/git-core/templates
mkdir -p "${therootdir}"usr/share/git-core/
ln -s /Developer/Git/share/git-core/templates "${therootdir}"usr/share/git-core/templates

rm -r -f "${therootdir}"usr/share/gitweb
ln -s /Developer/Git/share/gitweb "${therootdir}"usr/share/gitweb

git_binary_size=`stat -c%s ${thedir}/libexec/git-core/git`
libexec_git_files=`find ${thedir}/libexec/git-core -maxdepth 1 -size ${git_binary_size}c`
gitremoteftp_binary_size=`stat -c%s ${thedir}/libexec/git-core/git-remote-ftp`
libexec_gitremote_files=`find ${thedir}/libexec/git-core -maxdepth 1 -size ${gitremoteftp_binary_size}c`

save_wd=`pwd`
cd ${thedir}/libexec/git-core

for theFile in $libexec_git_files
do
        filename=`basename "${theFile}"`
        if test "x${filename}x" = "xgitx"; then
                echo it is git itself
        else
                echo soft-linking "${filename}" "~" git
                rm -f "${filename}"
                ln -s git "${filename}"
                chown root "${filename}"
                chgrp wheel "${filename}"
        fi
done

for theFile in $libexec_gitremote_files
do
        filename=`basename "${theFile}"`
        if test "x${filename}x" = "xgit-remote-ftpx"; then
                echo it is git-remote-ftp itself
        else
                echo soft-linking "${filename}" "~" git-remote-ftp
                rm -f "${filename}"
                ln -s git-remote-ftp "${filename}"
                chown root "${filename}"
                chgrp wheel "${filename}"
        fi
done

cd "${save_wd}"

bin_files=`find ${thedir}/bin -maxdepth 1 -size ${git_binary_size}c`

save_wd=`pwd`
cd ${thedir}/bin

for theFile in $bin_files
do
        filename=`basename "${theFile}"`
        if test "x${filename}x" = "xgitx"; then
                echo it is git itself
                echo soft-linking it "${thedir}/bin/git" "~" "${thedir}/libexec/git-core/git"
                rm -f git
                ln -s ../libexec/git-core/git git
                chown root git
                chgrp wheel git
        else
                echo soft-linking "${filename}" "~" git
                rm -f "${filename}"
                ln -s git "${filename}"
                chown root "${filename}"
                chgrp wheel "${filename}"
        fi
done

cd "${save_wd}"

bin_files=`find ${thedir}/bin -maxdepth 1`

for theFile in $bin_files
do
        if [ ! -d "${theFile}" ]; then
                filename=`basename "${theFile}"`
                echo linking ${thedir}/bin/"${filename}" "~" "${therootdir}"usr/bin/"${filename}"
                rm -f "${therootdir}"usr/bin/"${filename}"
                ln -s ${thedir}/bin/"${filename}" "${therootdir}"usr/bin/"${filename}"
                chown root "${therootdir}"usr/bin/"${filename}"
                chgrp wheel "${therootdir}"usr/bin/"${filename}"
        fi
done

mkdir -p "${therootdir}"usr/libexec/git-core

libexec_files=`find ${thedir}/libexec/git-core -maxdepth 1`

for theFile in $libexec_files
do
	if [ ! -d "${theFile}" ]; then
        	filename=`basename "${theFile}"`

        	echo linking ${thedir}/libexec/git-core/"${filename}" "~" "${therootdir}"usr/libexec/git-core/"${filename}"
        	rm -f "${therootdir}"usr/libexec/git-core/"${filename}"
        	ln -s ${thedir}/libexec/git-core/"${filename}" "${therootdir}"usr/libexec/git-core/"${filename}"
        	chown root "${therootdir}"usr/libexec/git-core/"${filename}"
        	chgrp wheel "${therootdir}"usr/libexec/git-core/"${filename}"

        	echo linking ${thedir}/libexec/git-core/"${filename}" "~" "${therootdir}"usr/bin/"${filename}"
        	rm -f "${therootdir}"usr/bin/"${filename}"
        	ln -s ${thedir}/libexec/git-core/"${filename}" "${therootdir}"usr/bin/"${filename}"
        	chown root "${therootdir}"usr/bin/"${filename}"
        	chgrp wheel "${therootdir}"usr/bin/"${filename}"
        fi
done

man1_files=`find ${thedir}/man/man1 -maxdepth 1 -type f`

for theFile in $man1_files
do
        filename=`basename "${theFile}"`
        echo linking ${thedir}/man/man1/"${filename}" "~" "${therootdir}"usr/share/man/man1/"${filename}"
        rm -f "${therootdir}"usr/share/man/man1/"${filename}"
        ln -s ${thedir}/man/man1/"${filename}" "${therootdir}"usr/share/man/man1/"${filename}"
        chown root "${therootdir}"usr/share/man/man1/"${filename}"
        chgrp wheel "${therootdir}"usr/share/man/man1/"${filename}"
done

man3_files=`find ${thedir}/man/man3 -maxdepth 1 -type f`

for theFile in $man3_files
do
        filename=`basename "${theFile}"`
        echo linking ${thedir}/man/man3/"${filename}" "~" "${therootdir}"usr/share/man/man3/"${filename}"
        rm -f "${therootdir}"usr/share/man/man3/"${filename}"
        ln -s ${thedir}/man/man3/"${filename}" "${therootdir}"usr/share/man/man3/"${filename}"
        chown root "${therootdir}"usr/share/man/man3/"${filename}"
        chgrp wheel "${therootdir}"usr/share/man/man3/"${filename}"
done

man5_files=`find ${thedir}/man/man5 -maxdepth 1 -type f`

for theFile in $man5_files
do
        filename=`basename "${theFile}"`
        echo linking ${thedir}/man/man5/"${filename}" "~" "${therootdir}"usr/share/man/man5/"${filename}"
        rm -f "${therootdir}"usr/share/man/man5/"${filename}"
        ln -s ${thedir}/man/man5/"${filename}" "${therootdir}"usr/share/man/man5/"${filename}"
        chown root "${therootdir}"usr/share/man/man5/"${filename}"
        chgrp wheel "${therootdir}"usr/share/man/man5/"${filename}"
done

man7_files=`find ${thedir}/man/man7 -maxdepth 1 -type f`

for theFile in $man7_files
do
        filename=`basename "${theFile}"`
        echo linking ${thedir}/man/man7/"${filename}" "~" "${therootdir}"usr/share/man/man7/"${filename}"
        rm -f "${therootdir}"usr/share/man/man7/"${filename}"
        ln -s ${thedir}/man/man7/"${filename}" "${therootdir}"usr/share/man/man7/"${filename}"
        chown root "${therootdir}"usr/share/man/man7/"${filename}"
        chgrp wheel "${therootdir}"usr/share/man/man7/"${filename}"
done
